﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.FormattedLinkLabel;
using System.Drawing;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;

namespace _92920
{
    class MyCreation:IUIElementCreationFilter 
    {
        
        public static string[] SearchedWords { get; set; }

        string start = "<span style=\"background-color:#30cfb8; font-weight:bold;\">";
        string end = "</span>";

        Color backColorText = Color.Yellow;

        public Color BackColorText
        {
            get { return backColorText; }
            set { backColorText = value;
            start = string.Format("<span style=\"background-color:{0}; font-weight:bold;\">", System.Drawing.ColorTranslator.ToHtml(backColorText));
            }
        }


        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {

        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            FormattedTextUIElement t = parent as FormattedTextUIElement;
            if (t != null ) 
            {
                
                string s = ((CellUIElement)t.Parent.Parent).Cell.Text;
                if (MyCreation.SearchedWords == null)
                {
                    t.Value = new ParsedFormattedTextValue(s);
                    return false;
                }
                string[] matches = s.Split(' ');
               
                for (int i = 0; i < matches.Length; i++)
                {
                    foreach (string word in MyCreation.SearchedWords)
                    {
                        if (matches[i].ToLower().Contains(word.ToLower()) && !string.IsNullOrEmpty(word))
                        {
                            int startIndex = matches[i].ToLower().IndexOf(word.ToLower());
                            matches[i] = matches[i].Insert(startIndex + word.Length, end);
                            matches[i] = matches[i].Insert(startIndex, start);
                            break;
                        }
                    }
                }
               
               
                t.Value = new ParsedFormattedTextValue(string.Join(" ",matches));
            
            }
            
            
            return false;
        }

        #endregion

        
    }
}
